/*
 *	Copyright (C) 2007-2009 Gabest
 *	http://www.gabest.org
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA USA.
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */

#pragma once

#include "GSDialog.h"
#include "resource.h"
#include <streams.h>

class GSCaptureDlg : public GSDialog
{
	struct Codec
	{
		CComPtr<IMoniker> moniker;
		CComPtr<IBaseFilter> filter;
		wstring FriendlyName;
		_bstr_t DisplayName;
	};

	list<Codec> m_codecs;

	int GetSelCodec(Codec& c);

protected:
	void OnInit();
	bool OnCommand(HWND hWnd, UINT id, UINT code);

public:
	GSCaptureDlg();

	int m_width;
	int m_height;
	string m_filename;
	int m_colorspace;
	CComPtr<IBaseFilter> m_enc;
};
